package cn.gygxzc.envir.bus.message.impl;

import cn.gygxzc.envir.bus.entity.PushModel;
import cn.gygxzc.envir.bus.message.IMessagePusher;
import cn.gygxzc.tina.cloud.bus.constant.QueueName;
import cn.gygxzc.tina.cloud.bus.utils.GsonUtils;
import org.springframework.amqp.core.AmqpTemplate;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by niantuo on 2018/12/17.
 * 消息推送的服务
 */
@Service
public class MessagePusher implements IMessagePusher {

    private final AmqpTemplate amqpTemplate;

    @Autowired
    public MessagePusher(AmqpTemplate amqpTemplate) {
        this.amqpTemplate = amqpTemplate;
    }

    @Override
    public void pushTo(List<Long> userIds, PushModel model) {
        model.setToUserIds(userIds);
        amqpTemplate.convertAndSend(QueueName.PUSHER, GsonUtils.toJson(model));
    }
}
