package cn.tonyandmoney.tuon.qywx.service.impl

import cn.tonyandmoney.tuon.core.utils.DateUtils
import cn.tonyandmoney.tuon.qywx.dao.IDutyDao
import cn.tonyandmoney.tuon.qywx.entity.TDuty
import cn.tonyandmoney.tuon.qywx.service.IDutyService
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.stereotype.Service
import reactor.core.publisher.Mono
import java.util.*

/**
 * 值班操作
 */
@Service
class DutyServiceImpl : IDutyService {

    @Autowired
    private lateinit var dutyDao: IDutyDao

    override fun addDuty(duty: TDuty): Mono<Void> {
        return Mono.create {
            duty.createTime = DateUtils.today()
            dutyDao.insert(duty)
            it.success()
        }
    }

    override fun queryByDate(date: Date): Mono<List<TDuty>> {
        return Mono.create {
            val wrapper = QueryWrapper<TDuty>().apply {
                eq("duty_date", DateUtils.format(date, DateUtils.F_YYYYMMDD))
            }
            it.success(dutyDao.selectList(wrapper))
        }
    }
}